' ContentsMenu.Register.VBS V1.00 (C) yoshioka.teruo@nifty.com 2006-03-18
' ContentsMenu.Register.VBS associates Directory with ContentsMenu.VBS.
' Usage: Start ContentsMenu.Register.VBS

Option Explicit
Dim wShell
Dim sFolder
Dim pFolder
Dim Keys
Dim Key

sFolder=WScript.ScriptFullName
sFolder=Left(sFolder,InStrRev(sFolder,"\"))

pFolder=WScript.FullName
pFolder=Left(pFolder,InStrRev(pFolder,"\"))
If LCase(Right(pFolder,9))="\command\" Then
  pFolder=Left(pFolder,Len(pFolder)-8)
End If

Keys=Array(_
Array(_
"HKEY_CLASSES_ROOT\Directory\shell\Contents\command\",_
""""&pFolder&"WScript.EXE"" """&sFolder&"ContentsMenu.VBS"&""" ""%1""",_
"REG_SZ"),_
Array(_
"HKEY_CLASSES_ROOT\Directory\shell\Contents\",_
"Contents Menu",_
"REG_SZ"))

Set wShell=CreateObject("WScript.Shell")

For Each Key In Keys
  Register(Key)
Next
WScript.Quit

Sub Register(Key)
Dim Value
Dim Binary
Dim k

Value=RegRead(Key(0))
If Err And Err<>-2147024894 Then WScript.Echo Err,Err.Description
If IsArray(Value) Then
  Binary=0
  For k=UBound(Value) To 0 Step -1
    Binary=Binary*256+Value(k)
  Next
  Value=Binary
End If
Select Case MsgBox(_
  "KEY" & vbTAB & "'" & Key(0) & "'" & vbLf &_
  "OLD" & vbTAB & "'" & Value & "'" & vbLf &_
  "NEW" & vbTAB & "'" & Key(1) & "'" & vbLf ,_ 
  vbYesNoCancel+vbDefaultButton3,_
  WScript.ScriptName&" - Yes(Change) / No(Delete) / Cancel(Leave) ?")
Case vbCancel
  Exit Sub
Case vbYes
  Call RegWrite(Key(0),Key(1),Key(2))
Case Else
  Call RegDelete(Key(0))
End Select
If Err And Err<>-2147024894 Then WScript.Echo Err,Err.Description
End Sub

Function RegRead(Key)
RegRead="(Not Exists)"
On Error Resume Next
RegRead=wShell.RegRead(Key)
End Function

Sub RegWrite(Key,Value,DataType)
On Error Resume Next
Call wShell.RegWrite(Key,Value,DataType)
End Sub

Sub RegDelete(Key)
On Error Resume Next
Call wShell.RegDelete(Key)
End Sub
